import { TGetTypeMapResolvers, TTypeMap } from '../../../lib/src/TypeMap-Types';
export type TTemplateVarString<VarName> = VarName extends string ? `{${VarName}}` : `TTemplateVarString, Name is not a string`;
export type TResolverVarString<VarName, VarValue> = VarName extends string ? VarValue extends string ? `{${VarName}=${VarValue}}` : `TResolverVarString, Value is not a string` : `TResolverVarString, Name is not a string`;
export type TExtractVarName<Var> = Var extends `{${infer VarName}=${string}}` ? VarName : Var extends `{${infer VarName}}` ? VarName : `Var is not a variable`;
export type TFilterResolverSegmentsWithVarName<TypeMap extends TTypeMap, VarName> = {
    [K in TGetTypeMapResolvers<TypeMap>]: K extends TResolverVarString<VarName, infer Value> ? Value : never;
};
export type TResolver = string;
export type TResolverValue = {
    value: string | undefined;
    type: 'text' | 'json' | 'html' | 'markdown';
    /**
     * Timestamp representing when this value was pulled from the server.
     */
    serverTimeMS: number;
};
export type TFullyResolvedResolver = string;
//# sourceMappingURL=Types.d.ts.map