export type TJsonTree<T = string> = T | {
    [segment: string]: TJsonTree<T>;
};
export type TJsonTreeMetadata = {
    flatIndex: number;
    currentPath: string;
    childrenCount: number;
    isShadow: boolean;
    sortedKeys: string[];
    isLeaf: boolean;
};
export type TJsonTreeWithMetadata = TJsonTree<{
    __metadata: TJsonTreeMetadata;
}>;
declare class JsonTreeBase {
    constructor();
    readonly _isLeaf: (obj: any) => boolean;
    createMetadataMap<T = string>(root: TJsonTree<T>, rootWithoutShadows?: TJsonTree<T>): {
        tree: TJsonTreeWithMetadata;
        resolversByIndex: Record<number, string>;
        indexByResolvers: Record<string, number>;
    };
    createShadowMap<T = string>(root: TJsonTree<T>): any;
}
export declare const JsonTree: JsonTreeBase;
export {};
//# sourceMappingURL=JsonTree.d.ts.map